.\" @(#)tcharge.1	1.3, 11MAY98 "
.TH TCHARGE 1.3 "11MAY98"
.UC
.SH NAME
tcharge \- telephone / modem charge watch for X window system
.SH SYNOPSIS
\fBtcharge\fP [ \fIoptions\fP ]
.SH DESCRIPTION
\fITcharge\fP is a tool to watch the time a telephone connection is up
and the money to pay for it. It works both for `per unit billing' and
for `per second billing'.
.br
On Invocation \fItcharge\fP pops up a window containing an analog
clock and an additional text field. The clock indicates the time
elapsed since the start of the program, while the text part of the
window gives information about the phone units and/or the charge spent
so far.
.br
Alternatively, \fItcharge\fP can work without any visual output at
all, quiet writing computed charges to files in the background.
.sp
\fITcharge\fP may either work in the \fIdaemon mode\fP or in a
\fInormal mode\fP.
.br
\fBDaemon mode:\fP If option \fI-watch-file <watch_file>\fP is choosen
the charge counting starts when \fIwatch_file\fP is created and stops when
\fIwatch_file\fP is deleted. For \fIPPP\fP take the name of the PID-file of
the \fIpppd\fP daemon. (So you do not have to terminate tcharge while
an entire X session.)
.br
(For ISDN use option `-isdn' instead)
.br
There is also a non-X-Window mode available by choosing the
commandline option \fI-noX\fP. Then the only output goes to a logfile
or to syslog.
.br
\fBNormal mode:\fP Charge computing starts immediately when
\fItcharge\fP comes up. For that tcharge is preferably started
directly after or before starting a modem connection (automatically)
and must be killed immediately after disconnect. (See options
\fI-file\fP on how to kill and \fI-before\fP and \fI-after\fP for
correction of delays.)
.sp
\fITcharge\fP can warn you some seconds before a new unit begins with
a little alarm like flashing the window or with a bell.
.br
When compiled with `-DREMINDER' \fItcharge\fP can warn at regular
intervals of having spent a certain amount of money, units or minutes
by popping up a message window.
.sp
\fITcharge\fP catches signals SIGHUP, SIGINT, SIGQUIT, SIGPIPE and
SIGTERM to print a connection statistic to a file or to syslog before
exiting (see option `-file') and to remove the tcharge PID-file before
exiting.
.sp
When compiled with `-DPRINT_CHARGE_STRUCTURE' an extended help option
\fI-help-charge\fP is available which prints a nice table of the
charge structure as given in the header file `charge.h' Very useful to
check the correct charging, especially when testing new TC
definitions!
.sp
Most of the source concerning X is derived from \fIrclock\fP written
by \fIRob Nation\fP. Since \fITcharge\fP is a derivate of \fIrclock\fP
it also conserves memory by not using the X toolkit or any widget set.
.SH SUPPORTED COUNTRIES
The phone companies of the following countries are supported so far:
.br
Germany, France, Japan, Portugal, Slovenia, Hungary, Belgium, Swiss,
Italy, Netherlands, South Africa, Spain, Danmark and the UK.
.sp
If you want tcharge to take into account e.g. some special discount
schemes or your provider charges, this is possible to realize - and
very easy for you even without any programming knowledge.
.SH OPTIONS
The options supported by \fItcharge\fP are listed below. If you prefer
the GNU-style long options, you may two hyphens instead of one.
.IP "\fB-help\fP"
Print a help message with \fItcharge\fP options.
.IP "\fB-version\fP"
Print \fItcharge\fP version and the name and date of the charge
definitions. Use this option for a first check of the charge
definitions.
.IP "\fB-help-charge\fP"
Prints a nice table of the charge structure as given in the header
file `charge.h' Very useful to check the correct charging. (Use this
first!)
.IP "\fB-geometry\fP \fIwindow-geometry\fP"
Create the window with the specified X window geometry.
.IP "\fB-bg\fP \fIcolor\fP"
Use the specified color as the window's background color.
.IP "\fB-fg\fP \fIcolor\fP"
Use the specified colour as the window's foreground color.
.IP "\fB-font\fP \fIfont_name\fP"
Specifies a font other than fixed to use for both, main and message window.
.IP "\fB-update\fP \fIn\fP"
Update clock face and telephone units every \fIn\fP seconds (default:
15 seconds). If the update rate is 1 second, a second hand will be
displayed.
.br
In \fIdaemon mode\fP tcharge will look for the file to watch every
\fIn\fP seconds but switches to \fIn=1\fP imediately when the file is
present (in order not to miss the end of the connection). Since the
start of the connection is determined by examining the creation time
of the file to watch there is no need to choose a unnecessary small update
value.
.IP "\fB-zone\fP \fIn\fP"
Choose the \fIregional zone\fP for the call. The zone number \fIn\fP
defaults to zero, usually for local area calls. If it is a long
distance call you have to choose higher values depending on your
telephone company (Germany: 0 to 3). Try option \fB-help\fP to get
more info.
.IP "\fB-holiday\fP"
"Today is a public holiday: use weekend charging."
.br
\fITcharge\fP keeps a list of public holidays for your country. If
this list is empty or incomplete (find out with option
\fI-help-charge\fP) you may easily complete the source file for your
country instead of using this option (see section BUGS).
.IP "\fB-before\fP \fIn\fP"
Assume connection started \fIn\fP seconds before \fItcharge\fP
started.
.IP "\fB-after\fP \fIn\fP"
Assume connection ends \fIn\fP seconds after termination of
\fItcharge.\fP
.IP "\fB-noclock\fP"
Do not draw a clock \- only print the units/charges spent so far.
.IP "\fB-noX\fP"
No X-Window-support at all: don't draw a clock or a textfield \- only
write connection statistics to the logfile or to syslog (use it with
option \fB-file\fP).
.IP "\fB-units-only\fP"
Print spent units (not the charge). Not available when `billing per
second' since `unit's are not calculated, but default
when `billing per unit'.
.IP "\fB-charge-only\fP"
Print charge (not the units). Default when `billing per
second'.
.IP "\fB-units-and-charge\fP"
print both, spent units and charge. Not available when `billing per
second'.
.IP "\fB-warn-seconds\fP \fIsec\fP"
Set off a little alarm \fIsec\fP seconds before the next unit begins
(see option \fI-bell\fP below for the meaning of this "little
alarm"). Tcharge \fIensures\fP that this alarm will not come too late
because of a large \fI-update\fP value! (But for that reason the alarm
may come \fIclockupdate\fP seconds to early ;-)
.br
This option is not available when `billing per second' since `unit's
are not calculated.
.IP "\fB-bell\fP"
Change the meaning of "little alarm" into a simple beep. (Default is a
short flashing of the screen e.g. switch to reverse video for a short
time and switch back.)
.br
A little alarm is set of in two cases:
.br
In case of \fIbilling per unit\fP when the option `-warn-seconds'
is given .
.br
In case of \fIbilling per second\fP when getting online and on
disconnect.
.IP "\fB-warn\fP \fBx\fP\fI@DM | \fBN\fPunits | \fBN\fPmin\fP"
Warn at regular intervals of having spent a certain amount of money,
units or minutes. `\fBN\fP' is an integer while `\fBx\fP' is a `float'
charge value. If the "name" of your currency (here "@DM") is a
abbreviation and contains a dot, don't let it out, e.g. "800L."
instead of "800L"!
.br
Everytime e.g. the number of units is equal to or greater than
\fBN\fP, 2\fBN\fP, 3\fBN\fP,... a message window will be popped up in
the center of the screen. When the user clicks a mouse button on the
window, it will be popped down. (Do \fInot\fP use the `kill' button
since this would kill \fItcharge\fP also!)
.br
Note: When the \fB-update\fP value is large, warnings will often come
lately!
.IP "\fB-file\fP \fIlogfile\fP"
Append connection statistics to the file `logfile' when the connection
is terminated or tcharge exits.
.br
Importand for \fI"normal mode"\fP:
.br
The charges will be written on exit of tcharge. Since Tcharge will not
terminate itself, you must kill it with an explicite kill
command. \fIDon't kill with signal 9 (SIGKILL)\fP since this would not
allow tcharge to do anything than instantly die. \fIUse signal SIGTERM
instead\fP ("kill -15 <tcharge-pid>" or simply "kill ..."). Instead of
"kill" you may use the command "killall tcharge". This will terminate
all open tcharge processes.
.IP "\fB-syslog\fP"
You may also go the official way and let tcharge log the charge
information via the system logging mechanism "syslog". Usually the
messages then will go to the file "message" (see file
"/etc/syslog.conf" for the location of it, e.g. "/var/log/".
.IP "\fB-user[=<username>]\fP"
When writing a connection summary (option \fI-file\fP or
\fI-syslog\fP) include the user name.
Use this option if you have more than one user having modem-access and
if you want to make charge statistics `per user'.
.sp
Normally, it's an easy task for a program to find out the name of the
user who invoked it; that's why setting the name explicitely (via
"=<username>") is only optional.  But if tcharge is started by some
e.g. initialization script of \fIpppd\fP (ip-up), then the user name
found by tcharge may be "root" or "ppp" instead of the real user
name. (If there is a difference between the \fIlogin\fP and the
\fIeffective\fP user ID, \fItcharge\fP will print both names.)
.IP "\fB-watch-file\fP \fIwatch_file\fP"
This option switches to \fIdaemon mode\fP, since tcharge does not
start charge computing as long as \fIwatch_file\fP does exist and you do
not have to terminate \fItcharge\fP to end charge computing.
.br
For \fBPPP\fP take the name of the PID-file of the \fIpppd\fP daemon
(usually \fB/var/run/ppp0.pid\fP). This way you may have tcharge in the
backround while an entire X session.
.br
This option is not available if \fItcharge\fP is compiled with the
`-DISDN' flag!
.IP "\fB-isdn\fP"
This option replaces the \fI-watch-file\fP option for \fIISDN\fP
users. Tcharge checks `/dev/isdninfo' for ISDN-connections.
.br
This option implies \fI-update 1\fP!
.IP "\fB-start\fP \fIseconds\fP"
Set the start time of the call. \fIseconds\fP must be given in
`time_t' (Standard Unix/C: seconds since 1.1. 1970). Read
`README.batch' on how to use tcharge for batch jobs (in connection
with option \fI-end\fP).
.br
Use the included script \fIdate2second\fP (see section \fITools\fP) to
generate time_t values from date/time.
.IP "\fB-end\fP \fIseconds\fP"
Set the end time
of the call. \fIseconds\fP must be given in `time_t' (see option
\fI-start\fP).
.br
If this option is given, \fItcharge\fP will \fInot\fP open a X-Window
and exit after computing the charge only once, so you might use
tcharge for batch jobs.
.IP "\fB-pidfile\fP \fI <pidfile>\fP"
Change location and/or name of the tcharge PID-file. Normally, the PID
file of tcharge is \fI/var/run/tcharge.pid\fP. If you don't have write
permissions for this directory, you can use this option.
.br
If you choose the special file name "false", no PID-file will be
written.
.SH SUMMARY INFORMATION
The format of the summary information you get with the \fB-file\fP
option (without option \fI-user\fP) is like this:
.sp
  07/06/1996 Connection [Wed, 15:56:54] -> [Wed, 16:16:15]
  07/06/1996 Duration: 00:19:21, units: 13, charge: 1.56 @DM
.sp
(Note: The format of the date is MM/DD/YYYY!).
.br
This feature may be used to get an overview over the money you spend
for the modem weekly or monthly. (See section \fITools\fP for a list of
included programs to evaluate files containing call summary files.)
.sp
The format of the syslog message (option\fB-syslog\fP) has a
different format:
.sp
.nf
Apr  2 00:34:22 moin tcharge[405]: Connection [Thu, 00:32:17]
.br
  -> [Thu, 00:34:22], duration: 00:02:00,
.br
Apr  2 00:34:22 moin tcharge[405]: units: 1, charge: 0.12 DM 
.fi
.SH TOOLS
.IP "\fBTools/summary\fP"
Perl script that extracts date and money fields from a logfile (option
\fI-file\fP) and lists charges monthly.
.IP "\fBTools/summary.log\fP"
Perl script to extract date and money fields from the syslog file
(option \fI-syslog\fP) and to list charges monthly.
.IP "\fBTools/parse_logfile\fP"
Perl script that uses tcharge in batch mode to calculate charges from
\fIpppd\fP syslog messages (see options \fI-start\fP and \fI-end\fP).
.IP "\fBTools/date2second\fP"
Perl Script to generate time_t values from date/time. (Needed for
options \fI-start\fP and \fI-end\fP.)
.br
To do the inverse: perl -e \'print scalar(localtime(<time_t value>)),
"\\n";'
.SH TCHARGE AND PPP
\fITcharge\fP should be started immediately before or after a modem
connection is up and should be killed after the connection
terminates. If you use \fIppp\fP you can configure the \fIip-up\fP and
\fIip-down\fP scripts to do this automatically. Because it takes a while
till the connection is established after the modem starts dialing (and
consumes phone time in this time), we have to add a correction time
via the \fB-before\fP option. Since there is also a delay between
termination of the ppp connection and hang-up of the modem, so we have
to use the \fB-after\fP option also. (Find out the delays by looking
at \fI/usr/adm/messages\fP!) Guess why there are \fItwo\fP options for
delays and not one e.g. `-longer' option!
.sp
Here an example \fB/etc/ppp/ip-up\fP script (executed automatically
by \fIpppd\fP when the connection is established). \fINote: tcharge\fP
tries to write a PID file (standard is /var/run/tcharge.pid). This is
only possible if \fItcharge\fP is executed by the superuser. Since
usually \fIpppd\fP has superuser privileges, this should be no problem.
.sp
.nf
#!/bin/sh
# other things:
echo interface-name: $1
echo tty-device: $2, speed: $3
echo local-IP-address: $4
echo remote-IP-address: $5
# tcharge:
TCHARGE=/usr/local/bin/tcharge
# File for statistical purpose:
STAT_FILE=$HOME/.telecom
#
if ! $TCHARGE -file $STAT_FILE -geometry +1+1 & then
  echo -e "\\a* Can not execute $TCHARGE!" >&2
  exit 1
fi
#
echo -n "Start ppp connection at "
date +%T
#(end)
.fi
.sp
Here an example \fB/etc/ppp/ip-down\fP script (executed
automatically by \fIpppd\fP when the connection is terminated):
.sp
.nf
#!/bin/sh
# File containing the PID of `tcharge':
PID_FILE=/var/run/tcharge.pid
# File for statistical purpose:
STAT_FILE=$HOME/.telecom
#
if [ ! -s $PID_FILE ]; then
  echo -e "\\a* File $PID_FILE does not exist or is empty!" >&2
  exit 1
fi
#
TC_PID=`cat $PID_FILE`
kill -15 $TC_PID
echo '******* Link terminated *** Charges: *******'
tail -2 $STAT_FILE
#(end)
.fi
.sp
\fBNote for "daemon mode":\fP
.br
The only thing the \fIip-up\fP script must do is to ensure that
\fItcharge\fP actually is started when pppd gets up. For that test if
it is and start \fItcharge\fP when it is not: So here a short version
of a \fBip-up for daemon mode\fP:
.sp
.nf
#!/bin/sh
TCHARGE_PID_FILE=/var/run/tcharge.pid
WATCH_FILE=/var/run/ppp0.pid
# test if tcharge is not running:
if ! test -e $TCHARGE_PID_FILE; then
  /usr/local/bin/tcharge -watch-file $WATCH_FILE
fi
#(end)
.fi
.SH TCHARGE AND ISDN
If \fItcharge\fP is compiled with the `-DISDN' flag (see Makefile) you
cannot choose the \fI-watch-file\fP option anymore and you have to
take the \fI-isdn\fP option instead. This one may call a bug but I
thought the `-watch-file' option is not useful for ISDN users (if you
don't agree, tell me about). I don't have access to ISDN, so I'm
not able to test anything (let's trust on Tillmann and his
pppcosts-code!-)
.sp
It's possible to extract much more detailed information from the Linux
ISDN driver `isdn4linux'. If you want to use this feature, I recommend
you to use the program \fIisdnlog\fP by Andreas Kool
<akool@Kool.f.EUnet.de> (For questions concerning \fIisdnlog\fP use
this address: <isdnlog@Kool.f.EUnet.de>)
.SH FILES
.IP "\fB@SRCDIR\fP"
All source files, charge module, documentation
and various tools for tcharge - especially all you need to accomodate
tcharge for your phone company.
.IP "\fB/var/run/tcharge.pid\fP"
If tcharge is run by someone with superuser privileges this file
contains the PID of tcharge.
.SH SUPPORT
There is also a \fBmailing list\fP for \fItcharge\fP. It is \fIopen\fP, so
everyone can directly post to the list. Yet everyone who wants to
susbscribe to the list is welcome. To subscribe to the list send an
e-mail with no subject and with the body
.sp
.ti +5
   subscribe your@email.address
.br
to
.ti +5
   tcharge-request@hix.physik.uni-bremen.de
.sp
To unsubscribe send an e-mail with the body
.sp
.ti +5
   unsubscribe your@email.address
.sp
to the same address. If you want to send some \fImail to the list,\fP
send it to
.sp
.ti +5
   tcharge@hix.physik.uni-bremen.de
.sp
For more information about this list's listserver send a mail with the
body \fI`help'\fP to `majordomo@hix.physik.uni-bremen.de'. The list is
intended for discussion of \fItcharge\fP, bug reports, help requests and
announcements of new releases, fixes, etc. (only the mails about new
releases will also be send to the newsgroup comp.os.linux.announce).
.SH CHARGE MODULES
You are encouraged to test the charge definition files that tcharge
provides and to help improving them.
.br
The charges that a modem produces are of course highly dependent on
your telephone company (TC). Though \fItcharge\fP supports a lot of
TCs (thanks to \fIpppcosts\fP!) there is still a lot to do since in
most cases there is something missing e.g. a complete list of public
holidays, support for more than the local area zone... And of course
the charge definitions are not correct forever; check if they need an
update!  I hope things will still get better: Nearly all TC-dependent
information is kept in single `charge files' that are easy to edit
(and to create) also for "non-hackers". (Actually you don't have to
know \fIanything\fP about programming!).
.br
Included in the source is a perl script \fImktc\fP that helps a lot to
configure tcharge for another TC (see README.TC).
.SH BUGS
All known bugs are eliminated...
.SH AUTHOR
Volker B"orchers <boercher@physik.uni-bremen.de>
.sp
Most X stuff is taken from \fBrclock\fP (version 1.81) written by:
Rob Nation (nation@rocket.sanders.lockheed.com)
.sp
The idea for the "daemon mode", the ISDN-support as well as the support
for most of supported countries is derived from `pppcosts',
(\fIpppcosts\fP by Tillmann Steinbrecher <tst@bigfoot.com>, see
.br
http://people.darmstadt.netsurf.de/tst/pppcosts.htm)
.sp
\fBThanks\fP to Sascha Ziemann (szi@aibon.ping.de), George
Antani(pitura@geocities.com), Oliver Gading (o.gading@sbu.ac.uk),
Frank Kalberg (skywalker@devnull.owl.de),
Michael.Schneider@vitrashop.com; special thanks to Heiko Brey
(cthuga@sl.netzservice.de) for our correspondence on the -noX option
and a special console option (never realized...). Thanks to Michael
Renner (renner@sunwan.mpik-tueb.mpg.de) - he found a bad bug in
tcharge and was the "major beta tester" of version 1.3. Very much
thanks to Markus Gutschke (gutschk@uni-muenster.de), author of
`isdnbutton' for his help on the ISDN-support.
